<template>
	<div class="snapshot-statistics-handle-order-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<vxe-grid v-bind="gridOptions" ref="gridRef">
				<template #form>
					<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline :disabled="gridOptions.loading">
						<el-form-item prop="crTime">
							<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
						</el-form-item>
						<el-form-item label="行业" prop="IndustryId">
							<el-select v-model="state.queryParams.IndustryId" class="w100" placeholder="请选择行业" @change="queryList" clearable>
								<el-option v-for="item in industry" :key="item.id" :label="item.name" :value="item.id" />
							</el-select>
						</el-form-item>
						<el-form-item>
							<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
							<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
								<SvgIcon name="ele-Refresh" class="mr5" />重置
							</el-button>
						</el-form-item>
					</el-form>
				</template>
			</vxe-grid>
		</div>
	</div>
</template>

<script lang="tsx" setup name="snapshotStatisticsHandleOrder">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { defaultDate } from '@/utils/constants';
import { getSSPStatisticsBaseData, getSSPStatisticsProcess, getSSPStatisticsProcessExport } from '@/api/snapshot/statistics';
import Other from '@/utils/other';
import { useRouter } from 'vue-router';

// 引入组件
const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件

// 定义变量内容
const state = reactive<any>({
	loading: false,
	queryParams: {
		// 查询参数
		crTime: defaultDate, // 时间默认今天开始到今天结束
		StartTime: null,
		EndTime: null,
		IndustryId: null,
	},
});

const requestParams = ref<EmptyObjectType>({});
const gridOptions = reactive<any>({
	loading: false,
	border: true,
	showOverflow: true,
	columnConfig: {
		resizable: true,
	},
	scrollY: {
		enabled: true,
		gt: 100,
	},
	toolbarConfig: {
		zoom: true,
		custom: true,
		refresh: {
			queryMethod: () => {
				handleQuery();
			},
		},
		tools: [{ toolRender: { name: 'exportAll' } }],
	},
	customConfig: {
		storage: true,
	},
	id: 'snapshotStatisticsHandleOrder',
	rowConfig: { isHover: true, height: 30, isCurrent: true, useKey: true },
	height: 'auto',
	align: 'center',
	columns: [
		{
			field: 'orgName',
			title: '部门名称',
			width: 200,
			fixed: 'left',
		},
		{
			field: 'orderCountNum',
			title: '信件总量',
			width: 100,
			fixed: 'left',
		},
		{
			title: '办件信息',
			children: [
				{
					field: 'ybOrderCountNum',
					title: '已办件数',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'ybOrderCountNum')} link>
									{row.ybOrderCountNum}
								</el-button>
							);
						},
					},
				},
				{
					field: 'zbOrderCountNum',
					title: '在办件数',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'zbOrderCountNum')} link>
									{row.zbOrderCountNum}
								</el-button>
							);
						},
					},
				},
				{
					field: 'completeOnTimeRate',
					title: '办结率',
					width: 100,
				},
				{
					field: 'receiveIn20Minutes',
					title: '20分钟内接件',
					width: 120,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'receiveIn20Minutes')} link>
									{row.receiveIn20Minutes}
								</el-button>
							);
						},
					},
				},
				{
					field: 'receiveOut20Minutes',
					title: '20分钟后接件',
					width: 120,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'receiveOut20Minutes')} link>
									{row.receiveOut20Minutes}
								</el-button>
							);
						},
					},
				},
				{
					field: 'promptResponse',
					title: '工单及时响应率',
					width: 120,
				},
				{
					field: 'backNum',
					title: '退回件',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'backNum')} link>
									{row.backNum}
								</el-button>
							);
						},
					},
				},
				{
					field: 'totalHandleDuration',
					title: '办件总时长(小时)',
					width: 140,
				},
				{
					field: 'end3Day',
					title: '3日内办结',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'end3Day')} link>
									{row.end3Day}
								</el-button>
							);
						},
					},
				},
				{
					field: 'end3To5Day',
					title: '3至5日办结',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'end3To5Day')} link>
									{row.end3To5Day}
								</el-button>
							);
						},
					},
				},
				{
					field: 'end5To7Day',
					title: '5至7日办结',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'end5To7Day')} link>
									{row.end5To7Day}
								</el-button>
							);
						},
					},
				},
				{
					field: 'end7Day',
					title: '7日外办结',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'end7Day')} link>
									{row.end7Day}
								</el-button>
							);
						},
					},
				},
				{
					field: 'closeOnTimeRate',
					title: '按时办结率',
					width: 100,
				},
				{
					field: 'satisfiedCount',
					title: '满意量',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'satisfiedCount')} link>
									{row.satisfiedCount}
								</el-button>
							);
						},
					},
				},
				{
					field: 'noSatisfiedCount',
					title: '不满意量',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'noSatisfiedCount')} link>
									{row.noSatisfiedCount}
								</el-button>
							);
						},
					},
				},
				{
					field: 'satisfiedRate',
					title: '满意率',
					width: 100,
				},
				{
					field: 'secondNum',
					title: '二次办理',
					width: 100,
					slots: {
						default({ row }) {
							return (
								<el-button type="primary" onClick={() => linkDetail(row, 'secondNum')} link>
									{row.secondNum}
								</el-button>
							);
						},
					},
				},
			],
		},
	],
	data: [],
	params: {
		exportMethod: getSSPStatisticsProcessExport,
		exportParams: requestParams,
	},
});
/** 搜索按钮操作 节流操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	gridOptions.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0]; // 受理时间
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime'); // 删除无用的参数
	getSSPStatisticsProcess(requestParams.value)
		.then((res) => {
			state.loading = false;
			gridOptions.data = res.result ?? [];
			gridOptions.loading = false;
		})
		.finally(() => {
			state.loading = false;
			gridOptions.loading = false;
		});
};
// 重置表单
const ruleFormRef = ref<any>(null); // 表单ref
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
// 跳转详情
const router = useRouter();
const linkDetail = (row: any, FieldName: string) => {
	router.push({
		path: '/snapshot/statistic/detailHandleOrder',
		query: {
			FieldName,
			OrgId: row.orgCode,
			IndustryId: state.queryParams.industryId,
			StartTime: state.queryParams.crTime[0],
			EndTime: state.queryParams.crTime[1],
		},
	});
};
const industry = ref<EmptyArrayType>([]);
// 获取基础数据
const getBaseData = () => {
	getSSPStatisticsBaseData()
		.then(({ result }) => {
			industry.value = result.industry ?? [];
		})
		.catch(() => {});
};
// 页面加载时
onMounted(() => {
	queryList();
	getBaseData();
});
</script>
